
package de.ivu.elect.business.kandidatenportal.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractWvpBenutzerEdit {

  @Inject
  protected WvpBenutzerDAO dao;

  @Inject
  protected WvpBenutzerExtendedDAO extendedDao;

  public void delete(WvpBenutzer entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(WvpBenutzer entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(WvpBenutzer entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected WvpBenutzer getAttachedEntity(WvpBenutzer entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected WvpBenutzer getAttachedAndRefreshedEntity(WvpBenutzer entity) {
    return dao.refresh(entity);
  }
}
